\name{getPUMS.2000}
\alias{getPUMS.2000}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Get data frames from Census 2000 5\% Public Use Microdata Sample (PUMS) File
%%  ~~function to do ... ~~
}
\description{
Splits a Census 2000 PUMS file into separate housing unit and person data frames and labels factor variables.  Optionally, will filter results by Public Use Microdata Area.

This program might take a little while; perhaps longer for large states.

Complete documentation of the Census 2000 PUMS are at

\url{www.census.gov/prod/cen2000/doc/pums.pdf}
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
getPUMS.2000(pums.file, PUMA5.filter = NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{pums.file}{Character string representing the file location of PUMS file. 
%%     ~~Describe \code{pums.file} here~~
}
  \item{PUMA5.filter}{Optional: vector of 5 diget FIPS codes for PUMAs to select.
%%     ~~Describe \code{PUMA5.filter} here~~
}
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
\item{house.file}{data frame of housing unit records}
\item{person.file}{data frame of person records}
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
# Download the zipped PUMS archive for Colorado
download.file('http://www2.census.gov/census_2000/datasets/PUMS/FivePercent/Colorado/all_Colorado.zip','coPUMS.zip')
# extract the PUMS records from the zipped archive
unzip(zipfile='coPUMS.zip',files='PUMS5_08.TXT')
PUMS.data <- getPUMS.2000('PUMS5_08.TXT', PUMA5.filter = c('00101','00102'))


##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function(pums.file, PUMA5.filter=NULL, working.dir="./"){
	# Load the data dictionaries
	load(paste(system.file(package='UScensus'),'/data/housing2000.dict.rda', sep=''))
	load(paste(system.file(package='UScensus'),'/data/person2000.dict.rda', sep=''))
	
	char.vec <- readLines(pums.file, n=-1)
	# Find out what type each row is
	record.type <- substr(char.vec,1,1)
	H.rows <- which(record.type=='H')
	P.rows <- which(record.type=='P')

	if(!is.null(PUMA5.filter)){
		PUMA5 <- substr(char.vec[H.rows],14,18)
		HSERIALNO <- substr(char.vec[H.rows],2,8)
		Hselect.rows <- which(match(PUMA5,PUMA5.filter, nomatch=0)>0)
		PSERIALNO <- substr(char.vec[P.rows],2,8)
		Pselect.rows <- which(match(PSERIALNO,HSERIALNO[Hselect.rows], nomatch=0)>0) 
		writeLines(text=char.vec[H.rows[Hselect.rows]], con=paste(working.dir,'PUMS5_H.TXT',sep=''))
		writeLines(text=char.vec[P.rows[Pselect.rows]], con=paste(working.dir,'PUMS5_P.TXT',sep=''))
		} else {
		writeLines(text=char.vec[H.rows], con=paste(working.dir,'PUMS5_H.TXT',sep=''))
		writeLines(text=char.vec[P.rows], con=paste(working.dir,'PUMS5_P.TXT',sep=''))
		}
	rm(char.vec)

	House.file<-read.fwf(file=paste(working.dir,'PUMS5_H.TXT',sep=''), widths=as.numeric(housing.dict[Hfirst.row,'LEN']), col.names=Hvarnames, colClasses='character')

	for(i in 1:length(Hvarnames)){# For each variable
		# Find the relevant rows in the data dictionary
		dict.rows <- which(housing.dict$VARIABLE==Hvarnames[i])
		# Find if it is a qualitative variable by looking for completely empty HI column
		if(!any(housing.dict[dict.rows,'HI']!='')){
			House.file[,i]<-factor(House.file[,i],levels=housing.dict[dict.rows,'LO'], labels=housing.dict[dict.rows,'VALUE DESCRIPTION'])
			}
		}

	Person.file<-read.fwf(file=paste(working.dir,'PUMS5_P.TXT',sep=''), widths=as.numeric(person.dict[Pfirst.row,'LEN']), col.names=Pvarnames, colClasses='character')

	for(i in 1:length(Pvarnames)){# For each variable
		# Find the relevant rows in the data dictionary
		dict.rows <- which(person.dict$VARIABLE==Pvarnames[i])
		# Find if it is a qualitative variable by looking for completely empty HI column
		if(!any(person.dict[dict.rows,'HI']!='')){
			if(any(person.dict[dict.rows,'LO']!='')){ #Ignore empty LO columns, these are 1\% variables anyway
				# There may still be empty LO rows, see RACE2, for example, these may be ignored
				if(any(person.dict[dict.rows,'LO']=='')){dict.rows<- dict.rows[-which(person.dict[dict.rows,'LO']=='')]}
				if(any(person.dict[dict.rows,'VALUE DESCRIPTION']=='Not used')){dict.rows<- dict.rows[-which(person.dict[dict.rows,'VALUE DESCRIPTION']=='Not used')]}
				Person.file[,i]<-factor(Person.file[,i],levels=person.dict[dict.rows,'LO'], labels=person.dict[dict.rows,'VALUE DESCRIPTION'])
				}
			}
		}
	return(list(House.file=House.file,Person.file=Person.file))	}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
