\name{getSF3.2000}
\alias{getSF3.2000}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Create a dataframe of summary Tables from SF3 of Census 2000
}
\description{Extracts summary tables from a state-level zipped file of Summary File 3 for the 2000 Decennial Census. An example of such a file is:
\url{http://www2.census.gov/census_2000/datasets/Summary_File_3/Colorado/all_colorado.zip}.  You will need to look at the data dictionary sf3.pdf - specifically Chapter 7 - in order to identify what the table names you will need to enter and to determine what the field values in the output are.
This documentation may be found at \url{http://www.census.gov/prod/cen2000/doc/sf3.pdf}
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
getSF3.2000(summary.table, geo.filter, state, zip.file)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{summary.table}{ A list of summary table names (e.g. list('P1','P2'))
%%     ~~Describe \code{summary.table} here~~
}
  \item{geo.filter}{A list of geography variables to filter on (e.g. list(SUMLEV=c('140')))
%%     ~~Describe \code{geo.filter} here~~
}
  \item{state}{The two-digit name of the state used in naming uf3 files (e.g. The file all_colorado.zip contains files called co00001_uf3.zip, co00002_uf3.zip, etc. The two-digit state name is 'co'.)
%%     ~~Describe \code{state} here~~
}
  \item{zip.file}{Path to zip file containing all uf3 files in a state
%%     ~~Describe \code{zip.file} here~~
}
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
A data frame of the selected geographies, with all of the fields from the geographic header file and the fields from the selected summary table(s).
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
# Download the zip file for Washington, DC.  This file is 12 MB and may take some time.
download.file('http://www2.census.gov/census_2000/datasets/Summary_File_3/District_of_Columbia/all_District_of_Columbia.zip','all_DC.zip')
# List files
unzip('all_DC.zip', list=TRUE)
state <- 'dc'
# Extract Summary Table P1 and H7 for all tracts (SUMLEV='140') in Washington, DC
dc.tracts <- getSF3.2000(summary.table=c('P1','H7'), geo.filter=list(SUMLEV=c('140')), state='dc', zip.file='all_DC.zip')
file.remove('all_DC.zip')

## Not Run
# Download tables P1 and P7 for all tracts and block groups in Boulder County, CO 
# First download http:///www2.census.gov/census_2000/datasets/Summary_File_3/Colorado/all_Colorado.zip 
# zip.file <- '{path to downloaded file}'
# getSF3.2000(summary.table=c('P1','P7'), geo.filter=list(SUMLEV=c('140','150'),COUNTY=c('013')), state='co', zip.file=zip.file)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
